/* Fake COM interface */
#ifndef FMPMDIF_H_PROCEED__
#define FMPMDIF_H_PROCEED__
#define FCSTDMETHODCALLTYPE __stdcall
typedef long FCHRESULT;
typedef unsigned long FCDWORD;
typedef FCDWORD FCULONG;
typedef void *FCLPVOID;
#if defined(__cplusplus)
typedef bool FCBOOL;
#else
typedef int FCBOOL;
#endif
typedef struct _FCIID
{
    unsigned long Data1;
    unsigned short Data2;
    unsigned short Data3;
    unsigned char Data4[8];
} FCIID, FCCLSID;
typedef enum _FCCLSCTX
{
	FCCLSCTX_INPROC_SERVER		= 0x1,
	FCCLSCTX_INPROC_HANDLER		= 0x2,
	FCCLSCTX_LOCAL_SERVER		= 0x4,
	FCCLSCTX_INPROC_SERVER16	= 0x8,
	FCCLSCTX_REMOTE_SERVER		= 0x10,
	FCCLSCTX_INPROC_HANDLER16	= 0x20,
	FCCLSCTX_INPROC_SERVERX86	= 0x40,
	FCCLSCTX_INPROC_HANDLERX86	= 0x80,
	FCCLSCTX_ESERVER_HANDLER	= 0x100
} FCCLSCTX;
#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM)
#define FCCLSCTX_ALL (FCCLSCTX_INPROC_SERVER | FCCLSCTX_INPROC_HANDLER | FCCLSCTX_LOCAL_SERVER | FCCLSCTX_REMOTE_SERVER)
#else
#define FCCLSCTX_ALL (FCCLSCTX_INPROC_SERVER | FCCLSCTX_INPROC_HANDLER | FCCLSCTX_LOCAL_SERVER)
#endif
#if defined(__cplusplus) && !defined(FCINTERFACE)
#define fcinterface struct
#define FCSTDMETHOD(method) virtual FCHRESULT FCSTDMETHODCALLTYPE method
#define FCSTDMETHOD_(type,method) virtual type FCSTDMETHODCALLTYPE method
#define FCPURE = 0
#define FCTHIS_
#define FCTHIS void
#define FCDECLARE_INTERFACE(iface) fcinterface iface
#define FCDECLARE_INTERFACE_(iface, baseiface) fcinterface iface : public baseiface
#define FCREFIID const FCIID &
#define FCREFCLSID const FCCLSID &
#else
#define fcinterface struct
#define FCSTDMETHOD(method) FCHRESULT (FCSTDMETHODCALLTYPE * method)
#define FCSTDMETHOD_(type,method) type (FCSTDMETHODCALLTYPE * method)
#define FCPURE
#define FCTHIS_ void * This,
#define FCTHIS  void * This
#define FCDECLARE_INTERFACE(iface) typedef fcinterface iface { struct iface##Vtbl * lpVtbl; } iface; typedef struct iface##Vtbl iface##Vtbl; struct iface##Vtbl
#define FCDECLARE_INTERFACE_(iface, baseiface) FCDECLARE_INTERFACE(iface)
#define FCREFIID const FCIID * const
#define FCREFCLSID const FCCLSID * const
#endif

#define FCIUNKNOWN_METHODS \
	FCSTDMETHOD(QueryInterface)(FCTHIS_ FCREFIID riid, FCLPVOID *ppvObject) FCPURE; \
	FCSTDMETHOD_(FCULONG, AddRef)(FCTHIS) FCPURE; \
	FCSTDMETHOD_(FCULONG, Release)(FCTHIS) FCPURE;
#define FCIPCMMUSICDRIVER_METHODS \
	FCIUNKNOWN_METHODS \
	FCSTDMETHOD_(FCBOOL, init)(FCTHIS_ char *path) FCPURE; \
	FCSTDMETHOD_(int, music_load)(FCTHIS_ char *filename) FCPURE; \
	FCSTDMETHOD_(int, music_load2)(FCTHIS_ void *musdata, int size) FCPURE; \
	FCSTDMETHOD_(char*, getmusicfilename)(FCTHIS_ char *dest) FCPURE; \
	FCSTDMETHOD_(void, music_start)(FCTHIS) FCPURE; \
	FCSTDMETHOD_(void, music_stop)(FCTHIS) FCPURE; \
	FCSTDMETHOD_(int, getloopcount)(FCTHIS) FCPURE; \
	FCSTDMETHOD_(FCBOOL, getlength)(FCTHIS_ char *filename, int *length, int *loop) FCPURE; \
	FCSTDMETHOD_(int, getpos)(FCTHIS) FCPURE; \
	FCSTDMETHOD_(void, setpos)(FCTHIS_ int pos) FCPURE; \
	FCSTDMETHOD_(void, getpcmdata)(FCTHIS_ short *buf, int nsamples) FCPURE;

#define FCIFMPMD_METHODS \
	FCIPCMMUSICDRIVER_METHODS \
	FCSTDMETHOD_(FCBOOL, loadrhythmsample)(FCTHIS_ char *path) FCPURE; \
	FCSTDMETHOD_(FCBOOL, setpcmdir)(FCTHIS_ char **path) FCPURE; \
	FCSTDMETHOD_(void, setpcmrate)(FCTHIS_ int rate) FCPURE; \
	FCSTDMETHOD_(void, setppzrate)(FCTHIS_ int rate) FCPURE; \
	FCSTDMETHOD_(void, setfmcalc55k)(FCTHIS_ FCBOOL flag) FCPURE; \
	FCSTDMETHOD_(void, setppzinterpolation)(FCTHIS_ FCBOOL ip) FCPURE; \
	FCSTDMETHOD_(void, setfmwait)(FCTHIS_ int nsec) FCPURE; \
	FCSTDMETHOD_(void, setssgwait)(FCTHIS_ int nsec) FCPURE; \
	FCSTDMETHOD_(void, setrhythmwait)(FCTHIS_ int nsec) FCPURE; \
	FCSTDMETHOD_(void, setadpcmwait)(FCTHIS_ int nsec) FCPURE; \
	FCSTDMETHOD_(void, fadeout)(FCTHIS_ int speed) FCPURE; \
	FCSTDMETHOD_(void, fadeout2)(FCTHIS_ int speed) FCPURE; \
	FCSTDMETHOD_(FCBOOL, getlength2)(FCTHIS_ char *filename, int *length, int *loop) FCPURE; \
	FCSTDMETHOD_(int, getpos2)(FCTHIS) FCPURE; \
	FCSTDMETHOD_(void, setpos2)(FCTHIS_ int pos) FCPURE; \
	FCSTDMETHOD_(char*, getpcmfilename)(FCTHIS_ char *dest) FCPURE; \
	FCSTDMETHOD_(char*, getppzfilename)(FCTHIS_ char *dest, int bufnum) FCPURE;


FCDECLARE_INTERFACE(FCIUnknown)
{
	FCIUNKNOWN_METHODS
};
typedef FCIUnknown *FCLPUNKNOWN;

FCDECLARE_INTERFACE_(IPCMMUSICDRIVER, FCIUnknown)
{
	FCIPCMMUSICDRIVER_METHODS
};


FCDECLARE_INTERFACE_(IFMPMD, IPCMMUSICDRIVER)
{
	FCIFMPMD_METHODS
};

FCDECLARE_INTERFACE_(IWINFMP, IFMPMD)
{
	FCIFMPMD_METHODS
	FCSTDMETHOD_(int, maskon)(FCTHIS_ FCBOOL rhythm_flag, int ah) FCPURE;
	FCSTDMETHOD_(int, maskoff)(FCTHIS_ FCBOOL rhythm_flag, int ah) FCPURE;
	FCSTDMETHOD_(void, setfmvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setssgvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setrhythmvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setadpcmvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setppzvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(int, getfmvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getssgvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getrhythmvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getadpcmvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getppzvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(char*, getcomment)(FCTHIS_ char *dest, void *musdata, int size) FCPURE;
	FCSTDMETHOD_(char*, getcomment2)(FCTHIS_ char *dest, void *musdata, int size) FCPURE;
	FCSTDMETHOD_(char**, getcomment3)(FCTHIS_ char *dest[], void *musdata, int size) FCPURE;
	FCSTDMETHOD_(int, fgetcomment)(FCTHIS_ char *dest, char *filename) FCPURE;
	FCSTDMETHOD_(int, fgetcomment2)(FCTHIS_ char *dest, char *filename) FCPURE;
	FCSTDMETHOD_(int, fgetcomment3)(FCTHIS_ char *dest[], char *filename) FCPURE;
	FCSTDMETHOD_(char*, getdefinedpcmfilename)(FCTHIS_ char *dest, void *musdata, int size) FCPURE;
	FCSTDMETHOD_(char*, getdefinedppzfilename)(FCTHIS_ char *dest, void *musdata, int size, int bufnum) FCPURE;
	FCSTDMETHOD_(int, fgetdefinedpcmfilename)(FCTHIS_ char *dest, char *filename) FCPURE;
	FCSTDMETHOD_(int, fgetdefinedppzfilename)(FCTHIS_ char *dest, char *filename, int bufnum) FCPURE;
	FCSTDMETHOD_(int, getsyncscnt)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getlastsyncexttime)(FCTHIS) FCPURE;
	FCSTDMETHOD_(void*, getworks)(FCTHIS) FCPURE;
	/* interface version 10 */
	FCSTDMETHOD_(void, setadpcmppz8emulate)(FCTHIS_ FCBOOL flag) FCPURE;
};

FCDECLARE_INTERFACE_(IPMDWIN, IFMPMD)
{
	FCIFMPMD_METHODS
	FCSTDMETHOD_(void, setppsuse)(FCTHIS_ FCBOOL value) FCPURE;
	FCSTDMETHOD_(void, setrhythmwithssgeffect)(FCTHIS_ FCBOOL value) FCPURE;
	FCSTDMETHOD_(void, setpmd86pcmmode)(FCTHIS_ FCBOOL value) FCPURE;
	FCSTDMETHOD_(FCBOOL, getpmd86pcmmode)(FCTHIS) FCPURE;
	FCSTDMETHOD_(void, setppsinterpolation)(FCTHIS_ FCBOOL ip) FCPURE;
	FCSTDMETHOD_(void, setp86interpolation)(FCTHIS_ FCBOOL ip) FCPURE;
	FCSTDMETHOD_(int, maskon)(FCTHIS_ int ch) FCPURE;
	FCSTDMETHOD_(int, maskoff)(FCTHIS_ int ch) FCPURE;
	FCSTDMETHOD_(void, setfmvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setssgvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setrhythmvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setadpcmvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(void, setppzvoldown)(FCTHIS_ int voldown) FCPURE;
	FCSTDMETHOD_(int, getfmvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getfmvoldown2)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getssgvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getssgvoldown2)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getrhythmvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getrhythmvoldown2)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getadpcmvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getadpcmvoldown2)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getppzvoldown)(FCTHIS) FCPURE;
	FCSTDMETHOD_(int, getppzvoldown2)(FCTHIS) FCPURE;
	FCSTDMETHOD_(char*, getmemo)(FCTHIS_ char *dest, void *musdata, int size, int al) FCPURE;
	FCSTDMETHOD_(char*, getmemo2)(FCTHIS_ char *dest, void *musdata, int size, int al) FCPURE;
	FCSTDMETHOD_(char*, getmemo3)(FCTHIS_ char *dest, void *musdata, int size, int al) FCPURE;
	FCSTDMETHOD_(int, fgetmemo)(FCTHIS_ char *dest, char *filename, int al) FCPURE;
	FCSTDMETHOD_(int, fgetmemo2)(FCTHIS_ char *dest, char *filename, int al) FCPURE;
	FCSTDMETHOD_(int, fgetmemo3)(FCTHIS_ char *dest, char *filename, int al) FCPURE;
	FCSTDMETHOD_(char*, getppcfilename)(FCTHIS_ char *dest) FCPURE;
	FCSTDMETHOD_(char*, getppsfilename)(FCTHIS_ char *dest) FCPURE;
	FCSTDMETHOD_(char*, getp86filename)(FCTHIS_ char *dest) FCPURE;
	FCSTDMETHOD_(int, ppc_load)(FCTHIS_ char *filename) FCPURE;
	FCSTDMETHOD_(int, pps_load)(FCTHIS_ char *filename) FCPURE;
	FCSTDMETHOD_(int, p86_load)(FCTHIS_ char *filename) FCPURE;
	FCSTDMETHOD_(int, ppz_load)(FCTHIS_ char *filename, int bufnum) FCPURE;
	FCSTDMETHOD_(void*, getopenwork)(FCTHIS) FCPURE;
	FCSTDMETHOD_(void*, getpartwork)(FCTHIS_ int ch) FCPURE;
};
const FCIID FCIID_IPCMMUSICDRIVER = {
	0x9D4D6317,0xF40A,0x455E,"\x9E\x2C\xCB\x51\x75\x56\xBA\x02"
};
const FCIID FCIID_IFMPMD = {
	0x81977D60,0x9496,0x4F20,"\xA3\xBB\x19\xB1\x99\x43\xDA\x6D"
};
const FCIID FCIID_IWINFMP = {
	0xB7910277,0x0295,0x4052,"\x9A\x65\x5A\xD4\x8D\x0F\x34\x77"
};
const FCIID FCIID_IPMDWIN = {
	0xC07008F4,0xCAE0,0x421C,"\xB0\x8F\xD8\xB3\x19\xAF\xA4\xB4"
};
const FCCLSID FCCLSID_WINFMP = { 0x3E7816B4,0xEB8F,0x435F,"\xBC\x37\x01\xCE\xDB\xF4\x22\x87" };
const FCCLSID FCCLSID_PMDWIN = { 0x97C7C3F0,0x35D8,0x4304,"\x8C\x1B\xAA\x92\x6E\x7A\xEC\x5C" };

/* typedef int FCSTDMETHODCALLTYPE GETVERSION_PROC_TYPE(void); */
typedef int FCSTDMETHODCALLTYPE GETVERSION_PROC_TYPE(void);
typedef int FCSTDMETHODCALLTYPE GETINTERFACEVERSION_PROC_TYPE(void);
typedef FCHRESULT FCSTDMETHODCALLTYPE COCREATEINSTANCE_PROC_TYPE(FCREFCLSID rclsid, FCLPUNKNOWN pUnkOuter, FCDWORD dwClsContext, FCREFIID riid, FCLPVOID * ppv);

#define FMP_DLL_NAME ("WinFMP.dll")
#define PMD_DLL_NAME ("PMDWin.dll")
#define FMP_GETVERSION_PROC_NAME ("fmp_getversion")
#define PMD_GETVERSION_PROC_NAME (FMP_GETVERSION_PROC_NAME+4)
#define FMP_GETINTERFACEVERSION_PROC_NAME ("fmp_getinterfaceversion")
#define PMD_GETINTERFACEVERSION_PROC_NAME (FMP_GETINTERFACEVERSION_PROC_NAME+4)
#define FMP_COCREATEINSTANCE_PROC_NAME ("fmp_CoCreateInstance")
#define PMD_COCREATEINSTANCE_PROC_NAME ("pmd_CoCreateInstance")
#define	FMP_INTERFACEVERSION 003
#define	FMP_INTERFACEVERSION_LIMIT 100
#define	PMD_INTERFACEVERSION 117
#define	PMD_INTERFACEVERSION_LIMIT 199

#define	FMPMD_OK					 	  0		/* I */
#define	FMPMD_WARNING_PPC_ALREADY_LOAD	 13		/* PPC ͂łɓǂݍ܂Ă */
#define	FMPMD_WARNING_P86_ALREADY_LOAD	 14		/* P86 ͂łɓǂݍ܂Ă */
#define	FMPMD_WARNING_PPS_ALREADY_LOAD	 15		/* PPS ͂łɓǂݍ܂Ă */
#define	FMPMD_WARNING_PPZ1_ALREADY_LOAD	 16		/* PPZ1 ͂łɓǂݍ܂Ă */
#define	FMPMD_WARNING_PPZ2_ALREADY_LOAD	 17		/* PPZ2 ͂łɓǂݍ܂Ă */

#endif
