/*
  [Win32ˑ]
    Windows APIbv܂B
    WCuƂ͏XdlقȂ܂B
*/
#include "win32l.h"
#undef NONLS
#include <windows.h>
#include "xstdlib.h"

/* XFILES */
XFILE XOPENRB(const char *path)
{
	HANDLE h = CreateFile(path, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 0);
	if (h == INVALID_HANDLE_VALUE) return 0;
	return (XFILE)h;
}

void XCLOSE(XFILE f)
{
	CloseHandle((HANDLE)f);
}

unsigned XREAD(XFILE f, void *b, unsigned l)
{
	DWORD w;
	if (ReadFile((HANDLE)f, b, l, &w, 0)) return w;
	return 0;
}

unsigned XSEEK(XFILE f, unsigned p)
{
	DWORD ret;
	ret = SetFilePointer((HANDLE)f, p, 0, FILE_BEGIN);
	return (ret != 0xFFFFFFFF) ? ret : 0;
}

unsigned XGETSIZE(XFILE f)
{
	DWORD ret;
	ret = GetFileSize((HANDLE)f, 0);
	if (ret == 0xffffffff) return 0;
	return ret;
}

void XMEMCPY(void *d, void *s, unsigned l)
{
	unsigned char *p1 = d, *p2 = s;
	while (l--) *p1++ = *p2++;
}

void XMEMSET(void *d, int n, unsigned l)
{
	unsigned char *p1 = d;
	while (l--) *p1++ = (unsigned char)n;
}

int XMEMCMP(void *s1, void *s2, unsigned l)
{
	unsigned char *p1, *p2;
	for (p1 = s1, p2 = s2; l--; p1++, p2++) if (*p1 != *p2) return ((int)*p1) - ((int)*p2);
	return 0;
}

int XMEMCMPI(void *s1, void *s2, unsigned l)
{
	unsigned char *p1, *p2;
	for (p1 = s1, p2 = s2; l--; p1++, p2++)
	{
		unsigned char c1, c2;
		c1 = ('A' <= *p1 && *p1 <= 'Z') ? *p1 | 0x20 : *p1 ;
		c2 = ('A' <= *p2 && *p2 <= 'Z') ? *p2 | 0x20 : *p2 ;
		if (c1 != c2) return ((int)c1) - ((int)c2);
	}
	return 0;
}

#if 0
int XSTRCMP(void *s1, void *s2)
{
	unsigned char *p1, *p2;
	for (p1 = s1, p2 = s2; *p1 && *p2; p1++, p2++) if (*p1 != *p2) return ((int)*p1) - ((int)*p2);
	return ((int)*p1) - ((int)*p2);
}
#endif

int XSTRCMPI(const char *s1, const char *s2)
{
	const unsigned char *p1 = (const unsigned char *)s1;
	const unsigned char *p2 = (const unsigned char *)s2;
	while (*p1 && *p2)
	{
		unsigned char c1, c2;
		c1 = ('A' <= *p1 && *p1 <= 'Z') ? *p1 | 0x20 : *p1 ;
		c2 = ('A' <= *p2 && *p2 <= 'Z') ? *p2 | 0x20 : *p2 ;
		if (c1 != c2) return ((int)c1) - ((int)c2);
		p1++;
		p2++;
	}
	return ((int)*p1) - ((int)*p2);
}

unsigned XSTRLEN(const char *s)
{
	unsigned ret = 0;
	while (*s++) ret++;
	return ret;
}

unsigned XSTRCPYN(char *d, const char *s, unsigned l)
{
	unsigned char *p1 = (unsigned char *)d;
	const unsigned char *p2 = (const unsigned char *)s;
	while (--l && *p2) *p1++ = *p2++;
	*p1 = 0;
	return p1 - (unsigned char *)d;
}

unsigned XMBLEN(const char *p)
{
	return IsDBCSLeadByte(*p) ? 2 : 1;
}

int XMULDIV(int n, int m, int d)
{
	return MulDiv(n, m, d);
}

unsigned XDIVPATH(char *d, const char *s, unsigned n)
{
	unsigned i = 0, j = 0;
	while (i < n - 1 && s[i])
	{
		unsigned l;
		if (s[i] == ':' || s[i] == '\\' || s[i] == '/') j = i + 1;
		l = XMBLEN(&s[i]);
		while (i < n - 1 && l--)
		{
			if (d) d[i] = s[i];
			i++;
		}
	}
	if (d) d[j] = 0;
	return j;
}

unsigned XDELEXT(char *d, const char *s, unsigned n)
{
	unsigned i = 0, j = 0;
	while (i < n - 1 && s[i])
	{
		unsigned l;
		if (s[i] == ':' || s[i] == '\\' || s[i] == '/') j = 0;
		if (s[i] == '.') j = i;
		l = XMBLEN(&s[i]);
		while (i < n - 1 && l--)
		{
			if (d) d[i] = s[i];
			i++;
		}
	}
	if (!j) j = i;
	if (d) d[j] = 0;
	return j;
}

void XGETCURDIR(char *d, unsigned l)
{
	GetCurrentDirectory(l, d);
}

void XSETCURDIR(const char *s)
{
	SetCurrentDirectory(s);
}

int XISHDD(const char *s)
{
	char d[4] = "?:\\";
	if (!s[0] || s[1] != ':') return 0;
	d[0] = s[0];
	return (GetDriveType(d) == DRIVE_FIXED);
}
