/*
  [Win32ˑ]
    DLL̏R[hƃAP[^łB
*/
#include "win32l.h"
#undef NONLS
#include <windows.h>
#include "xstdlib.h"

#if defined(_MSC_VER) && !defined(_DEBUG)
#pragma comment(linker,"/OPT:NOWIN98")
#pragma comment(linker,"/ENTRY:DllMain")
#endif

static HANDLE hheap = 0;
static char dllpath[MAX_PATH] = "";
static HINSTANCE hDLLInstance = 0;
static CRITICAL_SECTION globallock;

void XGLOBALLOCK(void)
{
	EnterCriticalSection(&globallock);
}
void XGLOBALUNLOCK(void)
{
	LeaveCriticalSection(&globallock);
}

char *XGETMODULEPATH(void)
{
	return dllpath;
}

void *XGETMODULEINSTANCE(void)
{
	return hDLLInstance;
}

void *XMALLOC(unsigned l)
{
	return HeapAlloc(hheap ? hheap : GetProcessHeap(), 0, l);
}

void *XREALLOC(void *p, unsigned l)
{
	return HeapReAlloc(hheap ? hheap : GetProcessHeap(), 0, p, l);
}

void XFREE(void *p)
{
	HeapFree(hheap ? hheap : GetProcessHeap(), 0, p);
}


BOOL WINAPI DllMain(
	HINSTANCE hinstDLL,
	DWORD fdwReason,
	LPVOID lpvReserved
)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		InitializeCriticalSection(&globallock);
		DisableThreadLibraryCalls(hinstDLL);
		if (!hheap) hheap = HeapCreate(0, 0, 0);
		hDLLInstance = hinstDLL;
		GetModuleFileName(hinstDLL, dllpath, MAX_PATH);
		XCRTINIT();
	}
	else if (fdwReason == DLL_PROCESS_DETACH)
	{
		XCRTTERM();
		if (hheap)
		{
			HeapDestroy(hheap);
			hheap = 0;
		}
		DeleteCriticalSection(&globallock);
	}
	return TRUE;
}
